format	PE GUI 4.0
entry	MyEntry

include '\Program Files\fasm\include\macro\masm.inc'
include '\Program Files\fasm\include\Win32axp.inc'

FILE_NOTIFY_INFORMATION struct
	NextEntryOffset		dd	?
	Action				dd	?
	FileNameLength		dd	?
	FileName			dw	?
FILE_NOTIFY_INFORMATION ends

	FILE_LIST_DIRECTORY		= 1
	FILE_NOTIFY_CHANGE_FILE_NAME	= 1h
	FILE_NOTIFY_CHANGE_DIR_NAME		= 2h
	FILE_NOTIFY_CHANGE_ATTRIBUTES	= 4h
	FILE_NOTIFY_CHANGE_SIZE			= 8h
	FILE_NOTIFY_CHANGE_LAST_WRITE	= 10h
	FILE_NOTIFY_CHANGE_LAST_ACCESS	= 20h
	FILE_NOTIFY_CHANGE_CREATION     = 40h
	FILE_NOTIFY_CHANGE_SECURITY		= 100h

section '.data'		data		readable	writeable
	_ClassName	db	'Drive Access', 0
	_AppName	db	'Drive Access', 0
	_DA_PathBuf	db	'C:\', 0
	_DAWT		db	'Drive Access '
	_DAChar		db	'\', 0
	_DAChars	db	'\|/-'
	_U2CD		db	'Unable to CreateFile for the Drive', 0

align	4
	gIst		dd	?
	gWnd		dd	?
	hAccel		dd	?
	ThreadID	dd	?
	ThreadHand	dd	?
	DACindex	dd	?
	wc			WNDCLASSEX
	msg			MSG

section '.code'	code readable executable

MyEntry:
	invoke	GetModuleHandle, 0
	mov		[gIst], eax

	mov		[wc.cbSize], sizeof.WNDCLASSEX
	mov		[wc.style], CS_HREDRAW or CS_VREDRAW or WS_TABSTOP
	mov		[wc.lpfnWndProc], WndProc
	mov		[wc.cbClsExtra], NULL
	mov		[wc.cbWndExtra], NULL
	push	[gIst]
	pop		[wc.hInstance]
	mov		[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		[wc.lpszMenuName], NULL
	mov		[wc.lpszClassName],  _ClassName
	invoke	LoadIcon, [gIst], IDI_APPLICATION
	mov		[wc.hIcon], eax
	mov		[wc.hIconSm], eax
	invoke	LoadCursor, NULL, IDC_ARROW
	mov		[wc.hCursor], eax
	invoke	RegisterClassEx, wc

	invoke	CreateWindowEx, WS_EX_CLIENTEDGE, _ClassName, _AppName, \
			WS_OVERLAPPEDWINDOW or WS_TABSTOP or WS_CLIPCHILDREN, \
			10, 10, 600, 500, NULL, NULL, \
			[gIst], NULL
	mov		[gWnd], eax

	invoke	LoadAccelerators, [gIst], _AppName
	mov		[hAccel], eax
	invoke	ShowWindow, [gWnd], SW_SHOWNORMAL
	invoke	UpdateWindow, [gWnd]
	.while TRUE
		invoke GetMessage, msg, NULL, 0, 0
		.if eax, e, 0
			jmp	@f
		.endif
		invoke	TranslateAccelerator, [gWnd], [hAccel], msg
		.if	eax, e, 0
			invoke	IsDialogMessage, [gWnd], msg
			.if eax, e, 0
				invoke TranslateMessage, msg
				invoke DispatchMessage, msg
			.endif
		.endif
	.endw
@@:
	mov     eax, [msg.wParam]
	invoke	ExitProcess, 0

WndProc	proc	hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
	.if [wmsg], e, WM_DESTROY
		invoke	PostQuitMessage, NULL
	.elseif [wmsg], e, WM_COMMAND
			mov	ecx, [lparam]
			mov	eax, [wparam]
			mov	edx, eax
			shr	edx, 16					;high order wParam
			cwde
	.elseif	[wmsg], e, WM_CREATE
			mov		eax, ThreadProc
			invoke	CreateThread, NULL, NULL, eax,\
					NULL, NORMAL_PRIORITY_CLASS,\
					ThreadID
			mov		[ThreadHand], eax
	.else
			invoke	DefWindowProc, [hwnd], [wmsg], [wparam], [lparam]
			jmp		.dir_out
	.endif
	xor		eax, eax
.dir_out:
	ret
WndProc	endp

ThreadProc	proc
local	hRDCW:DWORD
local	numBR:DWORD
local	bufRDCW[1024]:FILE_NOTIFY_INFORMATION			;FILE_NOTIFY_INFORMATION

;Code 'borrowed' from http://www.codeguru.com/Cpp/W-P/files/article.php/c4467/
;http://blogs.msdn.com/ericgu/archive/2005/10/07/478396.aspx
;http://www.codeproject.com/file/FileSpyArticle.asp

;these next 5 lines to touch all pages reserved for locals
	mov	eax, ebp
	.while eax, ae, esp
		mov dword [eax], 0	;touch the page with a 0 so as not to violate gaurd page
		sub eax, 1024		;should we check the next page?
	.endw
	invoke	CreateFile,													\	;Specify Directory to monitor
			_DA_PathBuf,													\	;path to monitor
			FILE_LIST_DIRECTORY,										\	;access (read/write) mode
			FILE_SHARE_READ or FILE_SHARE_DELETE or FILE_SHARE_WRITE,	\	;share mode
			NULL, 														\	;security descriptor
			OPEN_EXISTING,												\	;how to create
			FILE_FLAG_BACKUP_SEMANTICS,									\	;file attributes
			NULL															;file with attributes to copy
	.if eax, e, INVALID_HANDLE_VALUE
		invoke	MessageBox, 0, _U2CD, NULL, MB_OK
		invoke	ExitThread, 1
	.endif
	mov		[hRDCW], eax								;Handle for Directory to monitor
	mov		[DACindex], 0
	.while	TRUE										;Constantly monitor
		lea		eax, [bufRDCW]
		lea		ecx, [numBR]
		invoke	ReadDirectoryChangesW,						\
				[hRDCW],									\;handle to directory
				eax,										\;&Buffer, read results buffer
				1024 * sizeof.FILE_NOTIFY_INFORMATION,		\;length of buffer
				TRUE,										\;monitoring option, monitor subdirectories
				FILE_NOTIFY_CHANGE_SECURITY or				\;changes to watch
				FILE_NOTIFY_CHANGE_CREATION or				\;changes to watch
				FILE_NOTIFY_CHANGE_LAST_ACCESS or			\
				FILE_NOTIFY_CHANGE_LAST_WRITE or			\
				FILE_NOTIFY_CHANGE_SIZE or					\
				FILE_NOTIFY_CHANGE_DIR_NAME or				\
				FILE_NOTIFY_CHANGE_FILE_NAME,				\;filter conditions
				ecx,										\;&BytesReturned bytes returned
				NULL,										\;overlapped buffer
				NULL										;completion routine
		mov		eax, _DAChars
		add		eax, [DACindex]
		mov		al, byte [eax]
		mov		[_DAChar], al
		inc		[DACindex]
		and		[DACindex], 3
		invoke	SetWindowText, [gWnd], _DAWT				;make LED Blink Here!!!!!!!!!!!!!!!!!

	.endw

	ret

ThreadProc	endp


section '.idata'	import data readable writeable

	library	kernel32, 	'kernel32', \
			kernel32W,	'kernel32', \
			user32, 	'user32', \
			comctl32, 	'comctl32', \
			gdi32, 		'gdi32'

	include	'\progra~1\fasm\include\apia\kernel32.inc'
	include	'\progra~1\fasm\include\apia\user32.inc'
	include	'\progra~1\fasm\include\apia\comctl32.inc'
	include	'\progra~1\fasm\include\apia\gdi32.inc'

	import	kernel32W, \
			ReadDirectoryChangesW, 'ReadDirectoryChangesW'
